// Copyright 2011 Julian Phillips.  All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package py

// #include "utils.h"
//import "C"

import "unsafe"

type Code struct {
	AbstractObject
	o _PyCodeObject
}

// CodeType is the Type object that represents the Code type.
var CodeType = (*Type)(unsafe.Pointer(&*_PyCode_Type))

func newCode(obj *_PyObject) *Code {
	return (*Code)(unsafe.Pointer(obj))
}

func CompileFile(name string) (*Code, error) {
	fn := _CString(name)
	defer _free(unsafe.Pointer(fn))
	ret := _compileFile(fn)
	if ret == nil {
		return nil, exception()
	}
	return newCode(ret), nil
}

func codeCheck(obj Object) bool {
	if obj == nil {
		return false
	}
	return _codeCheck(c(obj)) != 0
}

func (code *Code) Eval(globals, locals Object) (Object, error) {
	pyCode := (*_PyCodeObject)(unsafe.Pointer(code))
	ret := _PyEval_EvalCode(pyCode, c(globals), c(locals))
	return obj2ObjErr(ret)
}
